Summary:	libmcrypt is a data encryption library
Name:		libmcrypt
Version:	2.5.8
Release:	5
License:	LGPLv2+
Group:		System Environment/Libraries
URL:		http://mcrypt.sourceforge.net/
Source0:	http://download.sourceforge.net/mcrypt/%{name}-%{version}.tar.bz2
Patch0:		%{name}-%{version}-aix.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root

Requires:	libtool >= 2.4.5-1

%define _libdir64 %{_prefix}/lib64

%description
libmcrypt is a data encryption library. The library is thread safe
and provides encryption and decryption functions. This version of the
library supports many encryption algorithms and encryption modes. Some
algorithms which are supported:
SERPENT, RIJNDAEL, 3DES, GOST, SAFER+, CAST-256, RC2, XTEA, 3WAY,
TWOFISH, BLOWFISH, ARCFOUR, WAKE and more.

The library is available as 32-bit and 64-bit.


%package devel
Group:		Development/Libraries
Summary:	Development libraries and headers for %{name}
PreReq:		%{name} = %{version}-%{release}

%description devel
Development libraries and headers for use in building applications that
use %{name}.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "xlc -q64" or "gcc -maix64".


%prep
%setup -q
%patch0
# update GNU autobuild system in libltdl
cd libltdl
autoconf
cd ..
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


%build
export CC="xlc_r"
export CXX="xlC_r"
export LDFLAGS="-Wl,-brtl"

# first build the 64-bit version
export OBJECT_MODE=64
cd 64bit
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --mandir=%{_mandir} \
    --enable-dynamic-loading \
    --enable-shared --enable-static
make %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-dynamic-loading \
    --enable-shared --enable-static
make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
cd 64bit
export OBJECT_MODE=64
make DESTDIR=${RPM_BUILD_ROOT} install
cd ../32bit
export OBJECT_MODE=32
make DESTDIR=${RPM_BUILD_ROOT} install

rm -f ${RPM_BUILD_ROOT}%{_libdir}/%{name}.a
rm -f ${RPM_BUILD_ROOT}%{_libdir64}/%{name}.a
/usr/bin/ar -X32 -rv ${RPM_BUILD_ROOT}%{_libdir}/%{name}.a ${RPM_BUILD_ROOT}%{_libdir}/%{name}.so
/usr/bin/ar -X64 -q  ${RPM_BUILD_ROOT}%{_libdir}/%{name}.a ${RPM_BUILD_ROOT}%{_libdir64}/%{name}.so

# these things don't belong here !!!
rm -f ${RPM_BUILD_ROOT}%{_libdir64}/libltdl*
rm -f ${RPM_BUILD_ROOT}%{_includedir}/ltdl*

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin lib lib64 include
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc 32bit/AUTHORS 32bit/COPYING.LIB 32bit/ChangeLog 32bit/KNOWN-BUGS
%doc 32bit/README 32bit/NEWS 32bit/THANKS 32bit/TODO
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so
%dir %{_libdir}/%{name}
%dir %{_libdir64}/%{name}
%{_libdir}/%{name}/*.so
%{_libdir64}/%{name}/*.so
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*
/usr/lib/%{name}
/usr/lib64/%{name}


%files devel
%defattr(-,root,system,-)
%doc 32bit/doc/README.key 32bit/doc/README.xtea 32bit/doc/example.c
%{_bindir}/*
%{_includedir}/*
%{_libdir}/*.la
%{_libdir64}/*.la
%{_libdir}/%{name}/*.a
%{_libdir}/%{name}/*.la
%{_libdir64}/%{name}/*.a
%{_libdir64}/%{name}/*.la
%dir %{_libdir}/%{name}
%dir %{_libdir64}/%{name}
%{_mandir}/man3/*
%{_datadir}/aclocal/*
/usr/bin/*
/usr/include/*
/usr/lib/*.la
/usr/lib64/*.la
/usr/lib/%{name}/*.a
/usr/lib/%{name}/*.la
/usr/lib64/%{name}/*.a
/usr/lib64/%{name}/*.la


%changelog
* Fri Dec 05 2014 Michael Perzl <michael@perzl.org> - 2.5.8-5
- rebuilt against latest version of libtool (2.4.5)

* Fri Dec 05 2014 Michael Perzl <michael@perzl.org> - 2.5.8-4
- added the missing 64-bit libraries again
- adapted the build process to newer GNU autotools versions

* Sun Jun 21 2013 Michael Perzl <michael@perzl.org> - 2.5.8-3
- added proper AIX shared libraries

* Thu Sep 11 2008 Michael Perzl <michael@perzl.org> - 2.5.8-2
- added dependency on libtool

* Fri Jun 06 2008 Michael Perzl <michael@perzl.org> - 2.5.8-1
- first version for AIX V5.1 and higher
